#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#       RGB.py
#       
#       Copyright 2013 Stefan Mavrodiev, Olimex LTD
#		23.01.2013 17:10:11
#       
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#       
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#       
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.



import sys
import time

ol = 0x48
device = 0x05

try:    
    from termcolor import colored
except ImportError:
    print "Termcolor module is not installed."
 
 
def PrintF(string, color):	
	try:
		print colored(string, color)
	except:
		print string
	return 

print 'Loading SMBus module....',   
try:
    import smbus
    PrintF('Done', 'green')
except ImportError:
    PrintF('Fail', 'red')    
    sys.exit(0)
   
 
def GetAddress():
	try:
		addr = int(raw_input("Address: "),16)				
	except Exception:
		print 'Invalid address'
		
	return addr
def GetVersion():
	revision = "0000"
	try:
		f = open('/proc/cpuinfo' , 'r')
		for line in f:
			if line[0:8] == 'Revision':
				length = len(line)
				revision =line[11:length-1]
		f.close()
	except:
		revision = "0000"
		
	return revision
def main():
	
	print "Checking RPi version...",
	PrintF('Done', 'green')
        
	print "Revision: " + colored(GetVersion(), 'white')
	
	print "Initializating SMBus...",
	try:
		ver = GetVersion()
		if ver == "0002" or ver == "0003":
			bus = smbus.SMBus(0)
		else:
			bus = smbus.SMBus(1) 
		PrintF('Done', 'green')
	except Exception, e:
		PrintF('Fail', 'red')
		print "Error: "
		PrintF(e, 'white')
		sys.exit(0)
		
		
		
	PrintF('\nMOD-RGB', 'white')
	print '----------------------------'
	print ''
	print colored('1. ', 'white') + 'Start PWM'
	print colored('2. ', 'white') + 'Stop PWM'
	print colored('3. ', 'white') + 'Set PWM'
	print colored('4. ', 'white') + 'Start AUDIO'
	print colored('5. ', 'white') + 'Stop AUDIO'
	print colored('6. ', 'white') + 'Set Address'
	print colored('0. ', 'white') + 'EXIT'
	print ''
	print ''
	
	while True:
		try:
			x = int(raw_input("Enter: "),10)
			if x < 0 or x > 7:
				raise
			else:
				break
				
		except Exception:
			try:
				print 'Number must be between ' + colored('0', 'white') + ' and ' + colored('6', 'white') 
			except:
				print 'Number must be between 0 and 6'
		
	if x == 1:
		address = GetAddress()
		command = 0x01
		buff = [address, command]
		print 'Sending data...',
		try:		
			bus.write_i2c_block_data(ol, device, buff)
			PrintF('Done', 'green')
		except Exception, e:
			PrintF('Fail', 'red')
			print "Error: ",
			PrintF(e, 'white')
			sys.exit(0)
			
	elif x == 2:
		address = GetAddress()
		command = 0x02
		buff = [address, command]
		print 'Sending data...',
		try:		
			bus.write_i2c_block_data(ol, device, buff)
			PrintF('Done', 'green')
		except Exception, e:
			PrintF('Fail', 'red')
			print "Error: ",
			PrintF(e, 'white')
			sys.exit(0)
			
	elif x == 3:
		address = GetAddress()
		command = 0x03
		
		while True:
			try:
				R = int(raw_input('R: '), 10)
				if R < 0 or R > 255:
					raise
				else:
					break
			except Exception:
				try:
					print 'R must be between ' + colored('0', 'white') + ' and ' + colored('255', 'white')
				except:
					print 'R must be between 0 and 255'
					
		while True:
			try:
				G = int(raw_input('G: '), 10)
				if G < 0 or G > 255:
					raise
				else:
					break
			except Exception:
				try:
					print 'G must be between ' + colored('0', 'white') + ' and ' + colored('255', 'white')
				except:
					print 'G must be between 0 and 255'
					
		while True:
			try:
				B = int(raw_input('B: '), 10)
				if B < 0 or B > 255:
					raise
				else:
					break
			except Exception:
				try:
					print 'B must be between ' + colored('0', 'white') + ' and ' + colored('255', 'white')
				except:
					print 'B must be between 0 and 255'
			
		buff = [address, command, R, G, B]
		
		
		
		print 'Sending data...',
		try:		
			bus.write_i2c_block_data(ol, device, buff)
			PrintF('Done', 'green')
		except Exception, e:
			PrintF('Fail', 'red')
			print "Error: ",
			PrintF(e, 'white')
			sys.exit(0)
			
			
	elif x == 4:
		address = GetAddress()
		command = 0x14
		buff = [address, command]
		print 'Sending data...',
		try:		
			bus.write_i2c_block_data(ol, device, buff)
			PrintF('Done', 'green')
		except Exception, e:
			PrintF('Fail', 'red')
			print "Error: ",
			PrintF(e, 'white')
			sys.exit(0)
			
	elif x == 5:
		address = GetAddress()
		command = 0x15
		buff = [address, command]
		print 'Sending data...',
		try:		
			bus.write_i2c_block_data(ol, device, buff)
			PrintF('Done', 'green')
		except Exception, e:
			PrintF('Fail', 'red')
			print "Error: ",
			PrintF(e, 'white')
			sys.exit(0)
			
	elif x == 6:
		address = GetAddress()
		command = 0xB0
		
		while True:
			try:
				new_address = int(raw_input("New address: "), 16)
				break
			except Exception:
				print 'Invalid address'
				
				
		buff = [address, command, new_address]
		
		print 'Sending data...',
		try:
			bus.write_i2C_block_data(ol, device, buff)
			PrintF('Done', 'green')
		except Exception, e:
			PrintF('Fail', 'red')
			print "Error: ",
			PrintF(e, 'white')
			sys.exit(0)
			
		
	else:
		sys.exit(0)
		
	return 0

if __name__ == '__main__':
	main()

